<template>
  <header :class="{header: true, light: light, shadow: hasShadow}" ref="header">
    <nuxt-link class="logo-container" to="/" >
      <Logo :class="{logo: true, dark: light}" @click="isShowingDrawer = false"/>
    </nuxt-link>
    <TheHeaderNavigation class="nav" v-if="!collapsed" :light="light" />
    <TheHeaderAuth class="auth" :isLoggedIn="isLoggedIn" :light="light" :collapsed="collapsed" :avatar="avatar" v-if="!collapsed || isLoggedIn" />
    <Button 
      type="text" 
      round 
      size="sm" 
      color="white"
      v-if="collapsed" 
      :class="{menu: true, 'push-right': !isLoggedIn}" 
      :light="light"
      @click.native="changeDrawerState">
      <template #icon>
        <Menu class="menu__icon" v-if="!isShowingDrawer"/>
        <Close class="menu__icon" v-else/>
      </template>
    </Button>
    <TheNavigationDrawer 
      :isLoggedIn="isLoggedIn" 
      :light="light" 
      :show="isShowingDrawer" 
      v-if="collapsed"
      @routeClicked="isShowingDrawer = false"/>
  </header>
</template>

<script>
import TheHeaderNavigation from "@/components/layout/header/TheHeaderNavigation";
import TheHeaderAuth from "@/components/layout/header/TheHeaderAuth";
import TheNavigationDrawer from "@/components/layout/header/TheNavigationDrawer";
import Logo from "@/assets/svgs/logo.svg";
import Menu from "@/assets/svgs/menu.svg";
import Close from "@/assets/svgs/close.svg";
import Button from "@/components/base/Button"

export default {
  name: "TheHeader",
  components: {
    Logo,
    TheHeaderNavigation,
    TheHeaderAuth,
    TheNavigationDrawer,
    Menu,
    Close,
    Button
  },
  data() {
    return {
      width: 0,
      pageYOffset: 0,
      isShowingDrawer: false
    }
  },
  props: {
    light: {
      type: Boolean,
      default: false
    } 
  },
  computed: {
    isLoggedIn() {
      return this.$store.getters['auth/isLoggedIn'];
    },
    collapsed() {
      return this.width < 1100 ? true : false;
    },
    hasShadow() {
      return this.pageYOffset > 0 ? true : false;
    },
    avatar() {
      return this.$store.getters['auth/getUser'].profilePic ? 
        process.env.baseUrl + this.$store.getters['auth/getUser'].profilePic : 
        '/images/profile.png';
    }
  },
  methods: {
    onResize() {
      this.width = this.$refs.header.clientWidth;
    },
    onPageScrole() {
      this.pageYOffset = window.pageYOffset;
    },
    changeDrawerState() {
      this.isShowingDrawer = !this.isShowingDrawer;
    }
  },
  mounted() {
    this.width = this.$refs.header.clientWidth;
    this.pageYOffset = window.pageYOffset;
    window.addEventListener('resize', this.onResize);
    window.addEventListener('scroll', this.onPageScrole);
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.onResize);
    window.removeEventListener('scroll', this.onPageScrole);
  }
};
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables';

.header 
  font-size $font-size
  padding $container-padding
  @media only screen and (max-width: 600px) 
    padding: $container-padding--md
  @media only screen and (max-width: 450px) 
    padding: $container-padding--sm
  background-color $black
  color $light
  display flex
  align-items stretch
  direction rtl
  height $header-height
  position fixed
  top 0
  left 0
  width 100%
  z-index 1000
  transition box-shadow .2s ease-in
  &.light
    background-color $light
    color $grey
  &.shadow
    box-shadow $header-shadow

.logo 
  margin $header-logo-margin
  @media only screen and (max-width: 1100px)
    margin $header-logo-margin--md
  fill $primary
  height $header-logo-height
  &.dark 
    fill $grey 

.logo-container 
  display flex
  align-items center

.auth 
  margin-right auto

.menu
  align-self center
  &__icon
    fill $white

.push-right
  margin-right auto
</style>


